﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Runtime.InteropServices;
using System.Runtime.Serialization.Formatters.Binary;
using System.Windows.Forms;
using Microsoft.PointOfService;

namespace PaylinkUPOSDemo
{
    class Tracef
    {
        private static bool WindowFound = false;
        private static int WindowHandle = 0;

        [DllImport("User32.dll")]
        public static extern Int32 FindWindow(String lpClassName, String lpWindowName);

        [DllImport("user32.dll", CharSet = CharSet.Auto)]
        public static extern int SendMessage(int hWnd, int msg, int wParam, COPYDATASTRUCT lParam);

        private const int WM_COPYDATA = 0x4A;

        [StructLayout(LayoutKind.Sequential)]

        public class COPYDATASTRUCT
        {
            public int dwData = 0;     // 32 bit int to passed. Not used.
            public int cbData = 0;     // Length of string. Will be one greater because of null termination.
            public string lpData;      // String to be passed.

            public COPYDATASTRUCT()
            {
            }

            public COPYDATASTRUCT(string Data)
            {
                lpData = Data + "\0";      // Add null termination
                cbData = lpData.Length;    // Length includes null
            }
        }

        public static void format(string TheFormatString, params Object[] Arguments)
        {
            int ArgumentCount = Arguments.GetLength(0);
            string outputString;
            string HexValue;

            if (ArgumentCount >= 1)
            {
                HexValue = string.Format("0x{0:x2}", Arguments[0]);

                outputString = TheFormatString.Replace("<0>", Arguments[0].ToString());
                TheFormatString = outputString;

                outputString = TheFormatString.Replace("<0x>", HexValue);
                TheFormatString = outputString;
            }

            if (ArgumentCount >= 2)
            {
                HexValue = string.Format("0x{0:x2}", Arguments[1]);

                outputString = TheFormatString.Replace("<1>", Arguments[1].ToString());
                TheFormatString = outputString;

                outputString = TheFormatString.Replace("<1x>", HexValue);
                TheFormatString = outputString;
            }

            if (ArgumentCount >= 3)
            {
                HexValue = string.Format("0x{0:x2}", Arguments[2]);

                outputString = TheFormatString.Replace("<2>", Arguments[2].ToString());
                TheFormatString = outputString;

                outputString = TheFormatString.Replace("<2x>", HexValue);
                TheFormatString = outputString;
            }

            if (ArgumentCount >= 4)
            {
                HexValue = string.Format("0x{0:x2}", Arguments[3]);

                outputString = TheFormatString.Replace("<3>", Arguments[3].ToString());
                TheFormatString = outputString;

                outputString = TheFormatString.Replace("<3x>", HexValue);
                TheFormatString = outputString;
            }

            if (ArgumentCount >= 5)
            {
                HexValue = string.Format("0x{0:x2}", Arguments[4]);

                outputString = TheFormatString.Replace("<4>", Arguments[4].ToString());
                TheFormatString = outputString;

                outputString = TheFormatString.Replace("<4x>", HexValue);
                TheFormatString = outputString;
            }

            if (ArgumentCount >= 6)
            {
                HexValue = string.Format("0x{0:x2}", Arguments[5]);

                outputString = TheFormatString.Replace("<5>", Arguments[5].ToString());
                TheFormatString = outputString;

                outputString = TheFormatString.Replace("<5x>", HexValue);
                TheFormatString = outputString;
            }

            if (ArgumentCount >= 7)
            {
                HexValue = string.Format("0x{0:x2}", Arguments[6]);

                outputString = TheFormatString.Replace("<6>", Arguments[6].ToString());
                TheFormatString = outputString;

                outputString = TheFormatString.Replace("<6x>", HexValue);
                TheFormatString = outputString;
            }

            if (ArgumentCount >= 8)
            {
                HexValue = string.Format("0x{0:x2}", Arguments[7]);

                outputString = TheFormatString.Replace("<7>", Arguments[7].ToString());
                TheFormatString = outputString;

                outputString = TheFormatString.Replace("<7x>", HexValue);
                TheFormatString = outputString;
            }

            if (ArgumentCount >= 9)
            {
                HexValue = string.Format("0x{0:x2}", Arguments[8]);

                outputString = TheFormatString.Replace("<8>", Arguments[8].ToString());
                TheFormatString = outputString;

                outputString = TheFormatString.Replace("<8x>", HexValue);
                TheFormatString = outputString;
            }

            if (ArgumentCount >= 10)
            {
                HexValue = string.Format("0x{0:x2}", Arguments[9]);

                outputString = TheFormatString.Replace("<9>", Arguments[9].ToString());
                TheFormatString = outputString;

                outputString = TheFormatString.Replace("<9x>", HexValue);
                TheFormatString = outputString;
            }

            simple(TheFormatString);
        }

        public static void simple(string msg)
        {
            int Result;

            if (!WindowFound)
            {
                WindowHandle = FindWindow(null, "CatchTrace");
                WindowFound = (WindowHandle != 0);
            }

            if (!WindowFound)
            {
                return;
            }

            Result = SendMessage(WindowHandle, WM_COPYDATA, 0, new COPYDATASTRUCT(msg));
        }
    }
}
